;************************************************************************/
;*									*/
;*			Access A Single 1-Wire Device			*/
;*                                                                      */
;*              Author: Peter Dannegger                                 */
;*                      danni@specs.de                                  */
;*                                                                      */
;************************************************************************/
;-------------------------------------------------------------------------
;				Reset and write SKIP ROM
;-------------------------------------------------------------------------
;Input: none
;Used:	a0, a1
;
rtc_res_skip:
	ldi	a1, 480 * xtal / 1000000 / 7	;xtal < 3.2MHz !
_rrs1:	cbi	rtc_out, rtc_pin		;2
	sbi	rtc_ddr, rtc_pin		;2	low
	dec	a1				;1
	brne	_rrs1				;2
	ldi	a1, 480 * xtal / 1000000 / 6
_rrs2:	cbi	rtc_ddr, rtc_pin		;2	high
	dec	a1				;1
	ldi	a0, SKIP_ROM			;1
	brne	_rrs2				;2
;-------------------------------------------------------------------------
;				Write byte
;-------------------------------------------------------------------------
;Input: a0 = byte
;Used:	a0, a1
;
rtc_wr:
	sec					;a0 = 1 after 8 * ROR
_rtw1:	cli
	sbi	rtc_ddr, rtc_pin		;low
	ldi	a1, 60 * xtal / 1000000 / 3
	sbrc	a0, 0
	cbi	rtc_ddr, rtc_pin		;write 1 bit
_rtw2:	dec	a1
	brne	_rtw2
	cbi	rtc_ddr, rtc_pin		;high
	sei					;int enable
	ror	a0
	cpi	a0, 1
	brne	_rtw1
	ret
;-------------------------------------------------------------------------
;				Read byte
;-------------------------------------------------------------------------
;Output a0 = byte
;Used	a0, a1
;
rtc_rd:
	ldi	a0, 0x80			;C = 1 after 8 * ROR
_rtr1:	cli
	sbi	rtc_ddr, rtc_pin		;low
	ldi	a1, 15 * xtal / 1000000 / 3
	clc
	cbi	rtc_ddr, rtc_pin		;high
_rtr2:	dec	a1
	brne	_rtr2
	sbic	rtc_in, rtc_pin			;sample input
	sec
	sei					;interrupt enable
	ldi	a1, 45 * xtal / 1000000 / 3
_rtr3:	dec	a1
	brne	_rtr3
	ror	a0				;shift bit in
	brcc	_rtr1
	ret
;-------------------------------------------------------------------------
