;************************************************************************/
;*									*/
;*				Access DS1994				*/
;*                                                                      */
;************************************************************************/
;
rtc_read:
	ldi	a2, 32			;try to read 32 times
_rre1:	bst	a2, 0			;test flag
	rcall	rtc_res_skip		;reset and skip ROM command
	ldi	a0, READ_RAM
	rcall	rtc_wr
	ldi	a0, 0x03
	rcall	rtc_wr
	ldi	a0, 0x02
	rcall	rtc_wr
	ldi	zl, rtc_ptr
_rre2:	rcall	rtc_rd
	ld	r0, z
	cpse	r0, a0
	clt
	st	z, a0
	inc	zl
	cpi	zl, rtc_ptr + 6
	brne	_rre2
	ldi	a0, low(rtc_magic)
	cp	a0, rtc_magic0
	ldi	a0, high(rtc_magic)
	cpc	a0, rtc_magic1
	brne	_rre3			;wrong magic
	brts	rtc_high_z		;read successful
_rre3:	dec	a2
	brne	_rre1			;next try
;-------------------------------------------------------------------------
rtc_start:
	ldi	zh, high(2 * rtc_load)
	ldi	zl, low( 2 * rtc_load)
_rts1:	rcall	rtc_res_skip
_rts2:	lpm
	mov	a0, r0
	rcall	rtc_wr
	subi	zl, low(-1)
	sbci	zh, high(-1)
	cpi	zl, low(2 * rtc_load + 12)
	breq	_rts1
	cpi	zl, low(2 * rtc_load + 16)
	brne	_rts2
	rjmp	0			;restart
;-------------------------------------------------------------------------
rtc_high_z:
	rcall	rtc_res_skip
	ldi	a0, write_scr
	rjmp	rtc_wr			;now DS1994 = high impedance
;-------------------------------------------------------------------------
.equ	start_td = (start_year * 365 + start_year / 4 + start_day) * 24
.equ	start_tm = (start_td + start_hour) * 60
.equ	start_ts = (start_tm + start_minute) * 60 + start_second
;
rtc_load:
	.db	write_scr, 0x00, 0x02, 0xF8	;address 0x0200
	.db	0xD0, 0x00			;start RTC
	.db	byte1(start_ts), byte2(start_ts)
	.db	byte3(start_ts), byte4(start_ts)
	.db	low(rtc_magic), high(rtc_magic)
	.db	copy_scr, 0x00, 0x02, 0x08
;-------------------------------------------------------------------------