;************************************************************************/
;*									*/
;*			Clock / Calendar				*/
;*                                                                      */
;*              Author: Peter Dannegger                                 */
;*                      danni@specs.de                                  */
;*                                                                      */
;************************************************************************/
;
get_time:
	ldi	a1, high( 16 * 60 * 60 )	;16 hours
	clr	a2
	rjmp	_gti2
_gti1:	subi	hour, -16			;+16 hours
	rcall	tst_hour
_gti2:	sub	rtc_b1, a1
	sbc	rtc_b2, a2
	sbc	rtc_b3, a2
	brcc	_gti1
	add	rtc_b1, a1
	ldi	a1, 60				;1 minute
	rjmp	_gti4
_gti3:	rcall	inc_minute			;+1 minute
_gti4:	mov	second, rtc_b0
	sub	rtc_b0, a1
	sbc	rtc_b1, a2
	brcc	_gti3
	ret
;-------------------------------------------------------------------------
inc_second:				;count up time and date
	inc	second
	cpi	second, 60
	brcs	_iti4
	clr	second
inc_minute:
	inc	minute
	cpi	minute, 60
	brcs	_iti4
	clr	minute
	inc	hour
tst_hour:
	cpi	hour, 24
	brcs	_iti3
	subi	hour, 24
	inc	weekday
	cpi	weekday, 7
	brcs	_iti1
	ldi	weekday, 0
_iti1:	inc	day
	mov	a0, month		; 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12
	sbrc	month, 3
	inc	a0			; 1, 2, 3, 4, 5, 6, 7, 9,10,11,12,13
	andi	a0, 1			; 1, 0, 1, 0, 1, 0, 1, 1, 0, 1, 0, 1
	subi	a0, -30			;31,30,31,30,31,30,31,31,30,31,30,31
	cpi	month, 2
	brne	_iti2
	dec	a0			;29 days = leap year
	sbrs	year, 0
	sbrc	year, 1
	dec	a0			;28 days
_iti2:	cp	a0, day
	brcc	_iti3
	ldi	day, 1
	inc	month
	cpi	month, 13
	brcs	_iti3
	ldi	month, 1
	inc	year
_iti3:
;-------------------------------------------------------------------------
	cpi	weekday, 0		;check summer time
	brne	_iti4			;wd != 0 (sunday): no change
	cpi	day, 25
	brcs	_iti4			;d < 25 .. 31: no change
	set				;prepare for summer if march
	cpi	month, 3
	breq	_sum1
	cpi	month, 10
	brne	_iti4			;not march / september: no change
	clt				;prepare for winter if september
_sum1:	cpi	hour, 2
	brcs	_iti4			;hour below 2: no change
	brne	_sum2			;hour <= 3: change
	set				;hour = 2: summer
_sum2:	sbrs	flags, fsummer
	inc	hour			;winter -> summer
	bld	flags, fsummer		;update summer flag
	sbrs	flags, fsummer
	dec	hour			;summer -> winter
_iti4:	ret
;-------------------------------------------------------------------------
