;************************************************************************
;*									*
;*			Using Maxim 1-Wire Parts			*
;*									*
;*		Author: P. Dannegger					*
;*			danni@specs.de					*
;*									*
;************************************************************************
.nolist
;
.equ	start_year	= 3				;2003
.equ	start_day	= 31 + 28 + 31 + 30 + 31 + 7	;07.6.
.equ	start_hour	= 22
.equ	start_minute	= 24
.equ	start_second	= 0

.equ	rtc_magic	= 0xA55B
;
.include "lcdtrtc.h"				;register usage
.include "hardware.h"				;pin assignment
.include "macro.mac"
.list
.listmac
	rjmp	init
;-------------------------------------------------------------------------
;				Interrupt Handler
;-------------------------------------------------------------------------
	.org	ovf0addr
.include "ovf0int.inc"
;-------------------------------------------------------------------------
;				Initialization
;-------------------------------------------------------------------------
init:	ldi	zl, low( 2 * calbyte )
	ldi	zh, high( 2 * calbyte )
	lpm					;read calibration from Flash
	out	osccal, r0

	sbi	key_out, key_pin		;activate pull up

	ldi	a0, 1<<CS01^1<<CS00
	out	TCCR0, a0			;prescaler 1/64
	ldi	a0, 1<<TOIE0
	out	TIMSK, a0			;enable timer interrupt

	clr	flags
	clr	second
	clr	minute
	clr	hour
	ldi	day, 1
	ldi	month, 1
	clr	year
	ldi	weekday, 6			;1.1.2000 = Sa

	rcall	rtc_read			;read DS1994
	rcall	lcd_init
	rcall	get_time			;calculate start time
;-------------------------------------------------------------------------
;				Main Loop
;-------------------------------------------------------------------------
main:	incall	measure				;temperature measurement

_mai1:	lcd_pos	0				;line 1
	incall	display_clock			;diplay time

	lcd_pos	14				;line 1: pos 14,15
	rcall	display_weekday

	lcd_pos	16				;line2
	sbrc	flags, fdate
	incall	display_date			;display date or

	sbrs	flags, fdate
	incall	display_temp			;	 temperature

_mai2:	sbrs	key_reg, key_press
	rjmp	_mai3
	cbr	key_reg, 1<<key_press
	ldi	a0, 1<<fdate
	eor	flags, a0			;date / temperature
	rcall	lcd_clear
	rjmp	_mai1

_mai3:	rcall	rtc_read			;read DS1994
	eor	rtc_b0, second
	sbrs	rtc_b0, 0
	rjmp	_mai2

	rcall	inc_second			;one second gone
	rjmp	main
;-------------------------------------------------------------------------
.include "lcd164.inc"
.include "1w_rtc.inc"
.include "ds1994.inc"
.include "gettime.inc"
.include "1wire.inc"
.include "outval.inc"
.include "disptime.inc"
.include "dispwday.inc"
.include "dispdate.inc"
.include "disptemp.inc"
.include "measure.inc"
;-------------------------------------------------------------------------
.include "calc12_5.inc"
;-------------------------------------------------------------------------
