;*************************************************************************
.include "tn12def.inc"
;-------------------------------------------------------------------------
;				Constant definitions
;-------------------------------------------------------------------------
.equ	xtal		= 1200000	;1.2MHz (max 3.2MHz)

.equ	MATCH_ROM	= 0x55
.equ	SKIP_ROM	= 0xCC
.equ	SEARCH_ROM	= 0xF0

.equ	CONVERT_T	= 0x44
.equ	READ_T		= 0xBE
.equ	WRITE_T		= 0x4E
.equ	STORE_EE	= 0x48
.equ	RECALL_EE	= 0xB8

.equ	WRITE_SCR	= 0x0F
.equ	READ_SCR	= 0xAA
.equ	COPY_SCR	= 0x55
.equ	READ_RAM	= 0xF0

.equ	SEARCH_FIRST	= 0xFF	; start new search
.equ	PRESENCE_ERR	= 0xFE
.equ	DATA_ERR	= 0xFE
.equ	LAST_DEVICE	= 0x00
				; 0x01 ... 0x7F: continue searching

;-------------------------------------------------------------------------
;				Using register
;-------------------------------------------------------------------------
.equ	romcode_ptr	= 1		;point to 1 wire address (r1..r8)
.equ	rtc_ptr		= 1		;point to rtc time (r1..r6)
.def	rtc_b0		= r1
.def	rtc_b1		= r2
.def	rtc_b2		= r3
.def	rtc_b3		= r4
.def	rtc_magic0	= r5
.def	rtc_magic1	= r6

.def	SaveSreg	= r9		;for interrupt usage

.equ	temp_ptr	= 10		;point to temperature values
.def	temp1l		= r10		;low byte first
.def	temp1h		= r11
.def	temp2l		= r12
.def	temp2h		= r13

;-------------------------------------------------------------------------
.def	second		= r16		;display time
.def	minute		= r17
.def	hour		= r18
.def	day		= r19
.def	month		= r20
.def	year		= r21
.def	weekday		= r22

.def	key_reg		= r23		;only bit 3..0 used
.equ	key_state	= 2
.equ	key_press	= 3

.def	Flags 		= r23		;only bit 7..4 used
.equ	fsummer		= 4
.equ	fdate		= 5		;display date / temperature

.def	lcd_count	= r24		;count cursor position

.def	a0		= r27		;working registers
.def	a1		= r28
.def	a2		= r29		;lcd: a0..a2
.def	a3		= r31		;1wire: a0..a3, zl
;.def	zl		= r30		;z pointer
;.def	zh		= r31
;-------------------------------------------------------------------------
