;************************************************************************/
;*									*/
;*			DS1820 Temperature Measurement			*/
;*                                                                      */
;*              Author: Peter Dannegger                                 */
;*                      danni@specs.de                                  */
;*                                                                      */
;************************************************************************/
;-------------------------------------------------------------------------
;				Read Temperature Sensors
;-------------------------------------------------------------------------
measure_inline:
	ldi	a0, 0x7F			;mark no valid result
	mov	temp1h, a0
	mov	temp2h, a0
	ldi	a0, search_first		;search sensor
_rte1:	rcall	w1_rom_search
	cpi	a0, presence_err
	breq	_rte5
	mov	a3, a0
	ldi	zl, romcode_ptr
	ld	a1, z				;device code:
	cpi	a1, 0x10
	brne	_rte4				;no DS1820
	ldi	a0, READ_T			;read temperature
	rcall	w1_byte_wr
	rcall	w1_byte_rd			;low byte
	mov	temp2l, temp1l
	mov	temp1l, a0
	rcall	w1_byte_rd			;high byte
	mov	temp2h, temp1h
	mov	temp1h, a0
_rte4:	mov	a0, a3
	cpi	a0, LAST_DEVICE
	brne	_rte1
_rte5:
;-------------------------------------------------------------------------
;				Start Next Measurement
;-------------------------------------------------------------------------
;
	rcall	w1_reset
	cpi	a0, presence_err
	breq	_rte6
	ldi	a0, SKIP_ROM
	rcall	w1_byte_wr
	ldi	a0, CONVERT_T
	rcall	w1_byte_wr			;start measuring
	sbi	w1_out, w1_pin
	sbi	w1_ddr, w1_pin			;parasite power on
_rte6:	rjmp	measure_ret
;-------------------------------------------------------------------------
